PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.09):spam mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################Edit Below#####################
#Software for delivering emails to cell phone.
my $TOCELLPHONE="";
m4_ifdef(`Smtp',`
 ### Mail account for storing detected spam mails. Require -D Smtp
my $SpamPool="spam\@vrl.sys.wakayama-u.ac.jp";
 ### Mail account for cancelling stored spam mails. Require -D Smtp
my $SpamDel="";
',)
 ### If you want to show detected spams for everyone.
 ### You should specify -D RESTRICTED, which denies insecure operations.
 ### As well, specify -D ANONYMOUS for masking the receipient account.
m4_ifdef(`CHKCGI',`
m4_ifdef(`ANONYMOUS',`
my $anonymous ="(twada|spam)\@(wada1|vrl)\.sys\.wakayama-u\.ac\.jp";
my $replace ="someone\@somewhere\.in\.jp";
',)
',)
#################Edit Above######################

#################Don't edit lines below#####################
my $ME;
my $Cmdpath;
BEGIN{
  if ((my $top=rindex($0,"/")) >-1) {
     $ME=substr($0,$top+1);
     $Cmdpath=substr($0,0,$top);
  } else {$ME=$0; $Cmdpath=".";}
  push(@INC, $Cmdpath);
}
use PERL::NNIPF;
my $HOME;
my $sfn=defined($ENV{'SCRIPT_FILENAME'}) ? $ENV{'SCRIPT_FILENAME'}:"";
my $ehome=defined($ENV{'HOME'}) ? $ENV{'HOME'}:"";
if ((my $stp=rindex($sfn,'/public_html')) >-1) {
        $HOME=substr($sfn,0,$stp);
}else{ $HOME=$ehome;}
my  $BOUNDARY=$Cmdpath . "/_BOUNDARY_";
my  $PARAMS=$Cmdpath . "/_PARAMS_";
NNIPF::SetDict($Cmdpath."/_BADIP_",$Cmdpath."/_GOODIP_","_MBADIP_","_MGOODIP_");
my $MAILDIR=$HOME."/_MAILDIR_";
my $TRASHNAME= "_TRASH_";
my $NEWNAME= "_NEW_";
my $CURNAME= "_CUR_";
my $TMPNAME= "_TMP_";

my %Params;
sub ReadParams{
  %Params=();
  my $name;
  my $value;
  if (-e $PARAMS) {
     open IN, $PARAMS or die "$PARAMS:$!";
     while(<IN>){
     ($name, $value) = split(/ /, $_);
     $value =~ s/(.*)\n/$1/;
     $Params{$name}=$value;
  }
  close IN;
  }else{
   %Params=( T1, 0.65, AUTOBIP, 1, REFRESH, 180, showTRASH, 0, showTMP, 1,
             showNEW, 1, showCUR, 0, AUTOGIP, 0, T2, 0.35);
   WriteParams();
  }
}
sub WriteParams{
  my $name;
  my $value;
  open OUT, ">$PARAMS" or die "$PARAMS:$!";
  while (($name,$value)= each %Params) {
	print OUT "$name $Params{$name}\n";
  }
  close OUT;
}
ReadParams();
#################Don't edit above lines#####################
