m4_define(`CHKCGI')m4_include(CONF/conf.pl) 
######################################################
     use Encode;
     use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;
m4_ifdef(`Smtp',`
     use Net::SMTP;
',)
     
     use 5.008008;
     use strict;
     use warnings;
     
     my $DayFrom="0";
     my $DayTo="1";
     my $DayFixed=0;
     my %showall=();
     my $dir;
     my $statchange=0;    
     my @dirs=($NEWNAME, $TMPNAME, $CURNAME, $TRASHNAME);
     my $title;

#initialization
     $showall{'new'}=$Params{'showNEW'};
     $showall{'tmp'}=$Params{'showTMP'};
     $showall{'cur'}=$Params{'showCUR'};
     $showall{'trash'}=$Params{'showTRASH'};
     NNIPF::bRead($BOUNDARY);
##

m4_ifdef(`RESTRICTED',,`
     if (defined($ENV{"REMOTE_ADDR"})) {
        if (NNIPF::distinctiveness($ENV{"REMOTE_ADDR"},0) > $Params{"T1"}){
	   print "Content-type: text/html\n";
	   print "\n";
	   print "<HTML><BODY>\n";
	   print "You are regarded as a spam sender.\n Sorry.\n";
	   print "</BODY></HTML>\n";
           exit 1;}
     }
')
     my $reqm = defined($ENV{'REQUEST_METHOD'}) ? $ENV{'REQUEST_METHOD'}:"";
     my $QS;

if ($reqm eq "POST") {
  read(STDIN, $QS, $ENV{'CONTENT_LENGTH'});
  my @a = split(/&/, $QS);
  foreach my $x (@a) {
    my ($name, $value) = split(/=/, $x);
    $name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
    $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
    if (($DayFixed eq 0)&&($name eq "DT")) {
      $DayTo=$value;
    }elsif (($DayFixed eq 0)&&($name eq "DF")) {
      $DayFrom=$value;
    }elsif ($name eq "DP") {
      if ($value<8){
        $DayFrom=$value-1;
        $DayTo=$value;
        $DayFixed=1;
      }
m4_ifdef(`RESTRICTED',,`
    }elsif ($name eq "T2") {
      $Params{"T2"}=$value;
      $statchange = 1;
    }elsif ($name eq "T1") {
      $Params{"T1"}=$value;
      $statchange = 1;
    }elsif ($name eq "AUTOGIP") {
      $Params{"AUTOGIP"}=(($value)?1:0);
      $statchange = 1;
    }elsif ($name eq "AUTOBIP") {
      $Params{"AUTOBIP"}=(($value)?1:0);
      $statchange = 1;
    }elsif ($name eq "REFRESH") {
      $Params{"REFRESH"}=$value;
      $statchange = 1;
')
    }elsif ($name eq "NOSHOWALL") {
      $showall{$value}=0;
      $statchange = 1;
    }elsif ($name eq "SHOWALL") {
      $showall{$value}=1;
      $statchange = 1;
    }elsif ($name eq "DIR") {
      $dir=$value;
    }elsif ($value eq "NORMAL") {
      ####  Maildir/(cur|new|tmp) -> Maildir/new
      ToNomal($dir,$name);
    } elsif ($value eq "TRASH") {
      #### Maildir/(cur|new|tmp) -> TRASH
      ToTrash($dir,$name);
    } elsif ($value eq "RESQ"){
      #### "Normal" TRASH -> Maildir/new
      ToNomal2($dir,$name);
    } elsif ($name eq "ABIP"){
      ##### Add Bad IP
m4_ifdef(`RESTRICTED',,`
      NNIPF::IpDictAddEB($value);
')
      } elsif ($name eq "AGIP"){
        ##### Add Good IP
m4_ifdef(`RESTRICTED',,`
      NNIPF::IpDictAddEG($value);
')
        } elsif ($value eq "AGIP"){
          ##### Add Good IP from file
m4_ifdef(`RESTRICTED',,`
      my $RCV=NNIPF::rvf("$MAILDIR/$CURNAME/$name");
      my $OIP=NNIPF::officialIP($RCV);
      NNIPF::IpDictAddEG($OIP);
')
      } elsif ($value eq "ABIP"){
      ##### Add Bad IP from file
m4_ifdef(`RESTRICTED',,`
      my $RCV=NNIPF::rvf("$MAILDIR/$TRASHNAME/$name");
      my $OIP=NNIPF::officialIP($RCV);
      NNIPF::IpDictAddEB($OIP);
')
    } elsif ($name eq "MSG"){
      ##### Update Boundary File
m4_ifdef(`RESTRICTED',,`
      open OUTbf,"> $BOUNDARY" or die "$BOUNDARY:$!";
      $value =~ s/\r//g;
      print OUTbf $value;
      close(OUTbf);
      NNIPF::bRead($BOUNDARY);
')
     } 
  }
}elsif (($reqm eq "GET")&&(($QS=$ENV{'QUERY_STRING'}) ne "")) {
  #################GET start
  my @a = split(/&/, $QS);
  foreach my $x (@a) {
    my ($name, $value) = split(/=/, $x);
    if ($name eq "FILE")     { ShowMail($value);
    }elsif ($name eq "MTAOB"){ MTAOB($value);
    }elsif ($name eq "IP")   { IPmanage($value);
    }
  }
  exit;
  #################GET end
}

if ($statchange) {
     $Params{'showNEW'}=$showall{'new'};
     $Params{'showTMP'}=$showall{'tmp'};
     $Params{'showCUR'}=$showall{'cur'};
     $Params{'showTRASH'}=$showall{'trash'};
     WriteParams();
}

################## Main Routine Start
print "Content-type: text/html\n";
print "\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=Shift_JIS\">\n";
print "<TITLE>spam CONSOLE";
m4_ifdef(`RESTRICTED',`
print "<Restricted>";
',)
print "</TITLE>\n";
print "<meta http-equiv=Refresh content=$Params{'REFRESH'}>\n";
print "<meta http-equiv=\"Pragma\" content=\"no-cache\">\n";
print "<link rel=\"SHORTCUT ICON\" href=\"./DOC/minilogo.ico\">\n";
print "</HEAD>\n";
print "<BODY>\n";

#############################################################################
   print "<TABLE BORDER=0>\n";
   print "<TR VALIGN=top ALIGN=center>\n";
   print "<TD><A HREF=\"./DOC/MTAOBhowto.html\"> Received Field </A></TD>\n";
   print "<TD ROWSPAN=2><form method=\"POST\" action=\"$ME\">";
   print "<TABLE BORDER=2>\n";
   print "<TR VALIGN=center ALIGN=center>\n";
   print "<TD ROWSPAN=2>Filter<BR>Settings</TD>\n";
   print "<TD COLSPAN=2>AUTOGIP</TD>\n";
   print "<TD COLSPAN=2>AUTOBIP</TD>\n";
   print "<TD ROWSPAN=2>Threshold: 1&gt;\n";
   print "<input type=text size=4 name=\"T1\" value=$Params{'T1'}>\n";
   print "&gt;\n";
   print "<input type=text size=4 name=\"T2\" value=$Params{'T2'}>\n";
   print "&gt; 0</TD>\n";
   print "<TD ROWSPAN=2><input type=submit name=\"dummy\" value=\"Set\"></TD>\n";
   print "</TR><TR VALIGN=top ALIGN=center>\n";
   print "<TD><input type=radio name=\"AUTOGIP\" value=1 ",
         ($Params{'AUTOGIP'})?"checked":"",">on</TD>\n";
   print "<TD><input type=radio name=\"AUTOGIP\" value=0 ",
         ($Params{'AUTOGIP'})?"":"checked",">off</TD>\n";
   print "<TD><input type=radio name=\"AUTOBIP\" value=1 ",
         ($Params{'AUTOBIP'})?"checked":"",">on</TD>\n";
   print "<TD><input type=radio name=\"AUTOBIP\" value=0 ",
         ($Params{'AUTOBIP'})?"":"checked",">off</TD>\n";
   print "</TR></TABLE>\n";
   print "</form></TD></TR>\n";
   print "<TR VALIGN=top ALIGN=center>\n";
   print "<TD><A HREF=\"./DOC/README-j.html\"> README </A>\n";
   print "&nbsp;<A HREF=\"./DOC/WEB-interface.html\"> HELP </A></TD>\n";
   print "</TR></TABLE>\n";

   print "<TABLE BORDER=0>\n";
   print "<TR ALIGN=center VALIGN=top>\n";

   print "<TD>Web Settings</TD>\n";
   print "<TD><form method=\"GET\" action=\"$ME\">";
   print "<input type=submit name=\"IP\" value=\"IPchk\"></form></TD>\n";
   print "<TD><form method=\"GET\" action=\"$ME\">";
   print "<input type=submit name=\"MTAOB\" value=\"MTAOB\"></form></TD>\n";
   foreach $title (@dirs){
    print "<TD><form method=\"POST\" action=\"$ME\">";
    if ($showall{$title}){
      print "<input type=\"hidden\" name=\"NOSHOWALL\" value=\"$title\" >";
      print "<input type=submit value=\"Fold $title\"></form></TD>\n";
    }else{
      print "<input type=\"hidden\" name=\"SHOWALL\" value=\"$title\" >";
      print "<input type=submit value=\"Unfold $title\"></form></TD>\n";
    }
   }
   print "<TD><form method=\"POST\" action=\"$ME\">";
   print "<input type=submit value=\"Refresh\">\n";
   print "<input type=text size=4 name=\"REFRESH\" value=$Params{'REFRESH'}></form></TD>\n";

   print "</TR></TABLE>\n";

   print "<HR>\n";
#############################################################################

   foreach $title (@dirs){
      if ($title eq $TRASHNAME){
         DirRead("$MAILDIR/$title/",$DayFrom,$DayTo);
      }else{
         DirRead("$MAILDIR/$title/",0,1000);
      }
   }

print "</BODY>\n";
print "</HTML>\n";
exit(0);
################## Main Routine End


############################################
sub DirRead {
  my ($dir,$dayfrom, $dayto)=@_;
  my $DIR;
  my $endpos=length($dir);
  
  if (substr($dir,$endpos-1) eq "/") {$DIR=substr($dir,0,$endpos-1);}
  else {$DIR=$dir;}
  my $title=substr($DIR,rindex($DIR,"/")+1);
  
  my %List = ();
  my @result = ();
  my @Result = ( );;
  my $header;
  my @Buf =();
  
  my $now=time();
  my $Df=$dayfrom*86400;
  my $Dt=$dayto*86400;
  my $count = 0;
  my $Pas;
  my $filename;
  my $file;
  
  
  ## Sort mails by time
  opendir DH, $dir or die "$dir:$!";
  while ($file = readdir DH) {
    next if $file =~ /^\.{1,2}$/;
    $Pas = $now-substr($file,0,10);
    if (($Pas > $Df)&&($Pas <= $Dt)) {
      $filename=$dir . $file;
      open IN, $filename or die "$filename:$!";
      $header= NNIPF::HeaderAnalysis(\*IN,\@Buf,0);
      close(IN);
      # end of header reading
      if (($showall{$title} eq 1)||
          (($title=~/$NEWNAME|$CURNAME|$TMPNAME/)&&
           ($header->{'OIP'} ne "")&&($header->{'Dis'} >0.0))||
          (($title=~/$TRASHNAME/)&&
           ($header->{'OIP'} ne "")&&($header->{'Dis'} <1.0))
          ) {
        CorrectFrom(\$header->{'from'});
        CorrectSubj(\$header->{'subject'});
        #######################################################################
        
        $List{$file}->{'OIP'}=$header->{'OIP'}; 
        $List{$file}->{'Pas'}=$Pas; 
        $List{$file}->{'Dis'}=$header->{'Dis'};
        $List{$file}->{'Subj'}=$header->{'subject'}; 
        $List{$file}->{'From'}=$header->{'from'}; 
        $List{$file}->{'Rfrm'}=$header->{'Frm'}; 
        $result[$count++]=$file;
      }
    }
  }
  closedir DH;
  
  @Result= sort { $b cmp $a } @result;
  
  # cur or tmp
  if ($title =~ /$NEWNAME|$CURNAME|$TMPNAME/) {
    NewCurTmpShow($title,$count,\@Result,\%List);
  }else{
    TrashShow($title,$count,\@Result,\%List);
  }
}

# Show TRASH
sub TrashShow{
  my ($title, $count, $result, $list)=@_;
  my $tmp;
  my $i;
  
  ####################################################
  if ($count>0) {
    print "<TABLE>";
    print "<TR VALIGN=top ALIGN=LEFT>\n";
    print "<TD><H4>$title</H4></TD>\n";
    print "<TD>",$count, "items</TD>\n";
    print "</TR></TD></TABLE>\n";
  }
  
  if ($showall{$title}){DayButtons();}

  if ($count>0){
    ############################## Main Form
    print "<form method=\"POST\" action=\"$ME\">";
    print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
    print "<input type=submit value=\"Submit Below\">\n";
    ############################### Main Table
    print "<TABLE BORDER=4>\n";
    foreach $i (@$result) {
      
      print "<TR><TD ROWSPAN=4>\n";
      print "<input type=\"radio\" name=\"$i\" value=\"RESQ\">Nomal<BR>\n";
      if (($$list{$i}->{'OIP'} ne "")&&($$list{$i}->{'Dis'}<1.0)){
        print "<input type=\"radio\" name=\"$i\" value=\"ABIP\" checked >AddBIP<BR>\n";
      }
      print "</TD>";
      if ($$list{$i}->{'Dis'}<$Params{"T2"}) {
        print "<TD ROWSPAN=4 bgcolor=#FF0000>\n";
      }elsif ($$list{$i}->{'Dis'} < 1.0) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>\n";}
	else {print "<TD ROWSPAN=4>\n";}
      
      print int($$list{$i}->{'Dis'}*100),"</TD>";
      print "<TD>",MessageDate($i),"</TD></TR>\n";
      print "<TR><TD>",ckstr($$list{$i}->{'From'}),"</TD></TR>\n";
      print "<TR><TD><A href=\"$ME?FILE=$title/$i\">",ckstr($$list{$i}->{'Subj'}),"</A></TD></TR>\n";
      $tmp = $$list{$i}->{'OIP'}; $tmp =~ s:\.:\\\.:g;
      $$list{$i}->{'Rfrm'} =~ s:($tmp):<A href=\"$ME\?IP=$1\">$1</A>:g;
      print "<TR><TD>$$list{$i}->{'Rfrm'}</TD></TR>\n";
    }
    print "</TABLE>";
    print "</form method>\n";
  }
}


sub NewCurTmpShow{
  my ($title, $count, $result, $list)=@_;
  my $i;
  my $tmp;
  
    if ($count>0) {
      print "<TABLE BORDER=0>\n";
      print "<TR VALIGN=top ALIGN=center>\n";
      print "<TD>\n";
      print "<H4>$title</H4></TD>";
      print "<TD>",$count, "items</TD>\n";
      print "</TR></TD></TABLE>\n";

    print "<form method=\"POST\" action=\"$ME\">";
    print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
    print "<input type=submit value=\"Submit Below\">\n";
    print "<TABLE BORDER=4 align=>\n";
    
    foreach $i (@$result) {
      print "<TR><TD ROWSPAN=4>";
      print "<input type=\"radio\" name=\"$i\" value=\"TRASH\">Spam<BR>";
      if ($title =~ /$TMPNAME|$NEWNAME/) {
        print "<input type=\"radio\" name=\"$i\" value=\"NORMAL\">Nomal<BR>";
      }
      if ($title =~ /$CURNAME/) {
        if (($$list{$i}->{'OIP'} ne "")&&($$list{$i}->{'Dis'} >0.0)){
          print "<input type=\"radio\" name=\"$i\" value=\"AGIP\" checked >AddGIP<BR>\n";
        }
      }
      
      print "</TD>";
      if ($$list{$i}->{'Dis'} eq 1.0) { print "<TD ROWSPAN=4 bgcolor=#FF0000>\n";}
      elsif ($$list{$i}->{'Dis'} > $Params{"T1"}) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>\n";}
	     else {print "<TD ROWSPAN=4>\n";}
      print int($$list{$i}->{'Dis'} * 100),"</TD>";
      print "<TD>",MessageDate($i),"</TD></TR>\n";
      print "<TR><TD>",ckstr($$list{$i}->{'From'}),"</TD></TR>\n";
      print "<TR><TD><A href=\"$ME?FILE=$title/$i\">",ckstr($$list{$i}->{'Subj'}),"</A></TD></TR>\n";
      $tmp = $$list{$i}->{'OIP'}; $tmp =~ s:\.:\\\.:g;
      $$list{$i}->{'Rfrm'} =~ s:($tmp):<A href=\"$ME\?IP=$1\">$1</A>:g;
      print "<TR><TD>$$list{$i}->{'Rfrm'}</TD></TR>\n";
      print "</TR>\n";
    }
    print( "</TABLE>");
    print( "</form method>\n");
  }
}

sub ckstr{
my ($text)=@_;
  if (defined($text)) {return $text;}
  else {return "";}
}

sub DayButtons{
my $i;
    print "<TABLE><TR VALIGN=top ALIGN=LEFT>\n";
    for ($i=1; $i<8; $i++){
      print "<TD>";
      print "<form method=\"POST\" action=\"$ME\">";
      print "<input type=\"hidden\" name=\"DP\" value=\"$i\" >\n";
      print "<input type=submit value=\"$i\"",($DayTo eq $i)? "disabled":"",">";
      print "</form></TD>\n";
    }
    print "<TD><form method=\"POST\" action=\"$ME\">";
    print "(<input type=text size=2 name=\"DF\" value=$DayFrom >\n";
    print "-<input type=text size=2 name=\"DT\" value=$DayTo >)\n";
    print "<input type=\"hidden\" name=\"DP\" value=\"8\">";
    print( "<input type=submit value=\"Days\">\n");
    print "</form></TD>";
    print "</TR></TABLE>\n";
}

sub MessageDate{
  my ($i)=@_;
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
    = localtime(substr($i,0,10));
  $mon += 1;
  $year+=1900;
  return "$year/$mon/$mday $hour:$min:$sec";
}

######### From tmp/cur to new
sub ToNomal{
  my ($dir, $name) = @_;
m4_ifdef(`RESTRICTED',,`
  my $filename="$MAILDIR/$dir/$name";
  my $RCV=NNIPF::rvf($filename);
  my $OIP=NNIPF::officialIP($RCV);
  if ($OIP ne ""){NNIPF::IpDictAddEG($OIP);}
  if ($dir =~ /$TMPNAME|$NEWNAME/) {
    if ($TOCELLPHONE ne "") {system("cat $filename |$TOCELLPHONE");}
    if ($dir =~ /$TMPNAME/) {
      my $dfilename="$MAILDIR/$NEWNAME/$name";
      rename $filename, $dfilename;
    }
  }
')
}

######## From  tmp/cur to trash (does not require cancelling)
sub ToTrash{
  my ($dir, $name) = @_;
  my $filename="$MAILDIR/$dir/$name";
m4_ifdef(`RESTRICTED',,`
  my $RCV=NNIPF::rvf($filename);
  my $OIP=NNIPF::officialIP($RCV);
  if ($OIP ne ""){NNIPF::IpDictAddEB($OIP);}
')
m4_ifdef(`Smtp',`
  if ($SpamPool){
    open INdf, $filename or die "$filename:$!";
    my $smtp = Net::SMTP->new("localhost");
    $smtp->mail($ENV{REMOTE_USER});
    $smtp->to($SpamPool);
    $smtp->data();
    while (<INdf>) {$smtp->datasend($_);}
    $smtp->dataend();
    $smtp->quit;
    close(INdf);
  }
',)
m4_ifdef(`RESTRICTED',,`
  my $dfilename="$MAILDIR/$TRASHNAME/$name";
  rename $filename, $dfilename;
')
}

######### From trash to new (requires cancelling)
sub ToNomal2{
  my ($dir, $name) = @_;
  my $filename="$MAILDIR/$TRASHNAME/$name";
m4_ifdef(`RESTRICTED',,`
  my $RCV=NNIPF::rvf($filename);
  my $OIP=NNIPF::officialIP($RCV);
  if ($OIP){NNIPF::IpDictAddEG($OIP);}
  if ($TOCELLPHONE) {system("cat $filename |$TOCELLPHONE");}
  ############# This may be changed################
  $name =~ s/:2,.*//;
  #################################################
')
m4_ifdef(`Smtp',`
  if ($SpamDel){
    open INdf, $filename or die "$filename:$!";
    my $smtp = Net::SMTP->new("localhost");
    $smtp->mail($ENV{REMOTE_USER});
    $smtp->to($SpamDel);
    $smtp->data();
    while (<INdf>) {$smtp->datasend($_);}
    $smtp->dataend();
    $smtp->quit;
    close(INdf);
  }
',)
m4_ifdef(`RESTRICTED',,`
  my $dfilename = "$MAILDIR/$NEWNAME/$name";
  rename $filename, $dfilename;
')
}

################################################
sub ShowMail{
  ################# Read specified Mail
  my ($value)=@_;
  my $filename=$value;
  my $header;
  my @hBuf = ();
  my $flag=0;
  my $rflag=0;
  my $sflag=0;
  
  print "Content-type: text/html\n";
  print "\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=Shift-JIS\">\n";
  print "<TITLE>SHOW MAIL";
m4_ifdef(`RESTRICTED',`
print "<Restricted>";
',)
  print "</TITLE>\n";
  print "<link rel=\"SHORTCUT ICON\" href=\"./DOC/minilogo.ico\">\n";
  print "</HEAD>\n";
  print "<BODY>\n";
  print "<DIV align=right><A href=\"./DOC/SHOWhelp.html\">HELP</A></DIV><HR>\n";

################### Show MSG

  if (($filename =~ /$CURNAME\//)||
      ($filename =~ /$TMPNAME\//)||
      ($filename =~ /$NEWNAME\//)||
      ($filename =~ /$TRASHNAME\//)){
    $filename = $MAILDIR . "/" . $filename;$flag=1;
  }
  if ($flag){
    open IN,$filename or die "$filename:$!";
    $header= NNIPF::HeaderAnalysis(\*IN,\@hBuf,0);
    my $pat= $header->{'OIP'};
    $pat =~ s:\.:\\\.:g;
    # end of header reading
    my $i;
    foreach $i (@hBuf){

      if ($i =~ /^(Subject|From|Reply-To):/){
          $rflag=0;
          $sflag=1;
      }elsif ($i =~ /^Received:/){
	  $rflag=1;
          $sflag=0;
      }elsif ($i =~ /^(Date|Message-ID|Delivered-To|X-.*):/){
          $rflag=0;
          $sflag=0;
      }

      if ($sflag) {
        $i=encode('shiftjis', decode('MIME-Header',$i));
        if ($i=~ /^(.*)(.\$B.*\(B)(.*)$/){
          my $one=$1;
	  my $two=$2;
	  my $c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
          $i=sprintf("%s%s%s",$one,$two,$c);
        }else{escapeHTML(\$i); }
        $i=to_sjis($i);
      }else{
        escapeHTML(\$i);
        if ($rflag){
          $i =~ s:($pat):<font size="+2">$1</font>:g;
          $i =~ s:([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+):<A href="$ME?IP=$1">$1</A>:g;
          if ($i =~ /by ([A-z0-9._\-]+)/) {
            my $by  = $1;
            if (NNIPF::Checkb($by)){
              if ($by ne $header->{'by'}) {
                $i =~ s:($by):<font color=\#ff00ff>$1</font>:g;
              }else{
                $i =~ s:($by):<font color=red>$1</font>:g;
              }
            }else{
              $i =~ s:($by):<A href=\"$ME?MTAOB=$1\">$1</A>:g;
            }
          }
        }
      }
m4_ifdef(`ANONYMOUS',`
      $i =~ s/$anonymous/$replace/g;
',);
      print "$i<BR>\n";
    }
    print "<HR><PRE>\n";
    
m4_ifdef(`RESTRICTED',,`
    while(<IN>){
      $_ =to_sjis($_);
      escapeHTML(\$_);
      print "$_";
    }
    close(IN);
')
  }

  print "</PRE>\n";
  print "</BODY>\n";
  print "</HTML>\n";
}

################# Add MTAOB 
#############################################
sub MTAOB{
  my ($value)=@_;
  if ($value eq 'MTAOB') {$value="";}
  print "Content-type: text/html\n";
  print "\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=Shift-JIS\">\n";
  print "<TITLE>ADD $value in Boundary file?";
m4_ifdef(`RESTRICTED',`
print "<Restricted>";
',)
  print "</TITLE>\n";
  print "<link rel=\"SHORTCUT ICON\" href=\"./DOC/minilogo.ico\">\n";
  print "</HEAD>\n";
  print "<BODY>\n";

  print "<A href=\"$ENV{'HTTP_REFERER'}\"> Back</A>";
  print "<form method=\"POST\" action=\"$ME\">\n";
  print "<textarea name=\"MSG\" cols=50 rows=10>\n";
  open INbf, $BOUNDARY or die "$BOUNDARY:$!";
  while(<INbf>){ $_ =~ s/\n//; print "$_\n"; }
  close(INbf);
  if ($value) {print "$value\n";}
  print "</textarea><BR>";
  print "<input type=submit value=\"ADD $value in Boundary file\">";
  print "</form>";
  

  print "</BODY>\n";
  print "</HTML>\n";

}

######################################
sub IPmanage{
  my ($IP)=@_;
  my $Ratio = -1;
  $IP =~ s/(.*)\n/$1/;
  if ($IP =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/){
    $Ratio=NNIPF::distinctiveness($IP,0);
  } else{ $IP="Input IP"; }

  print "Content-type: text/html\n";
  print "\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=Shift_JIS\">\n";
  print "<TITLE>IP ADDR MANAGEMENT";
m4_ifdef(`RESTRICTED',`
print "<Restricted>";
',)
  print "</TITLE>\n";
  print "<meta http-equiv=\"Pragma\" content=\"no-cache\">\n";
  print "<link rel=\"SHORTCUT ICON\" href=\"./DOC/minilogo.ico\">\n";
  print "</HEAD>\n";
  print "<BODY>\n";

  print "<A href=\"$ENV{'HTTP_REFERER'}\"> Back</A>";
  print "<TABLE BORDER=0>\n";
  print "<TR VALIGN=top ALIGN=center>\n";
  print "<TD>\n";
  print "<form method=\"GET\" action=\"$ME\">";
  print "IP ADDRESS=<input type=text name=\"IP\" size=16 value=\"$IP\" ";
  if ($Ratio >=0) { print "disabled>\n";
    printf("Distinctiveness= %f%%\n", $Ratio*100);
  }else{
    print ">\n";
  }
  print "<input type=submit value=\"CHECK\">\n";
  print "</form>\n";
  print "</TD></TR><TR>\n";
  
  if (($IP ne '127.0.0.1')&&(NNIPF::IsPrivate($IP) eq 0) && ($Ratio ne 1.0)){
    print "<TD align=right>\n";
    print "<form method=\"POST\" action=\"$ME\">";
    print "<input type=\"hidden\" name=\"ABIP\" value=\"$IP\" >\n";
    print "<input type=submit value=\"AddBIP\">\n";
    print "</form>\n";
    print "</TD>\n";
  }

  if (($IP ne '127.0.0.1')&&(NNIPF::IsPrivate($IP) eq 0) && ($Ratio ne 0.0)){
    print "<TD align=right>\n";
    print "<form method=\"POST\" action=\"$ME\">";
    print "<input type=\"hidden\" name=\"AGIP\" value=\"$IP\" >\n";
    print "<input type=submit value=\"AddGIP\">\n";
    print "</form>\n";
    print "</TD>\n";
  }
  
  print "</TR>\n";
  print "</TABLE>\n";
  
  # If you want to check whois entry regarding $IP uncomment the following #xs.
m4_ifdef(`WHOIS',`
  if (($IP =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/)
      && ($IP ne "127.0.0.1")&&(NNIPF::IsPrivate($IP) eq 0)){
    print "<PRE>\n";
    open wIN, "whois $IP|" or die "whois: $!";
    while (<wIN>) {print $_;}
    close wIN;
    print "</PRE>\n";
  }
',)

print "</BODY>\n";
print "</HTML>\n";

}

################### Correcting 'from' ################################
sub CorrectFrom{
  my ($text)=@_;
  $$text=encode('shiftjis',decode('MIME-Header',$$text));
  # This code is for non-mime-encoded From. Should be replaced############
  if (defined($$text)&&($$text=~ /^(.*)(.\$B.*\(B)(.*)$/)){
    my $one=$1;
    my $two=$2;
    my $c=$3; escapeHTML(\$c);
    $$text =sprintf("%s%s%s",$one,$two,$c);
  }else{escapeHTML($text); }
  $$text=to_sjis($$text);
}
################### Correcting 'subject' ############################
sub CorrectSubj{
  my ($text)=@_;
  if (defined($$text)&&($$text =~ /=\?/)) {
    $$text =encode('shiftjis', decode('MIME-Header',$$text));
  }
  if (defined($$text)&&($$text =~ /^\s*$/)) {
    $$text = "**No Title**";
  }
}

sub escapeHTML{
  my ($text)=@_;
  
  if (defined($$text)){
  $$text =~ s/&/&amp;/g;
  $$text =~ s/</&lt;/g;
  $$text =~ s/>/&gt;/g;
  }
}

sub to_sjis {
  my($l) = @_;
  my $decoder = Encode::Guess->guess($l);
  
  return encode('shiftjis', $decoder->decode($l)) if ref($decoder);
  return encode('shiftjis', decode('shiftjis', $l)) if (defined($decoder)&&($decoder =~ /shiftjis/));
  return $l;
}
